/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the GoogleAnalytics4ControllerActionPropertyRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GoogleAnalytics4ControllerActionPropertyRequest{}

// GoogleAnalytics4ControllerActionPropertyRequest struct for GoogleAnalytics4ControllerActionPropertyRequest
type GoogleAnalytics4ControllerActionPropertyRequest struct {
	OAuthId   *string `json:"oAuthId,omitempty"`
	AccountId *int32  `json:"accountId,omitempty"`
}

// NewGoogleAnalytics4ControllerActionPropertyRequest instantiates a new GoogleAnalytics4ControllerActionPropertyRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGoogleAnalytics4ControllerActionPropertyRequest() *GoogleAnalytics4ControllerActionPropertyRequest {
	this := GoogleAnalytics4ControllerActionPropertyRequest{}
	return &this
}

// NewGoogleAnalytics4ControllerActionPropertyRequestWithDefaults instantiates a new GoogleAnalytics4ControllerActionPropertyRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGoogleAnalytics4ControllerActionPropertyRequestWithDefaults() *GoogleAnalytics4ControllerActionPropertyRequest {
	this := GoogleAnalytics4ControllerActionPropertyRequest{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *GoogleAnalytics4ControllerActionPropertyRequest) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalytics4ControllerActionPropertyRequest) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *GoogleAnalytics4ControllerActionPropertyRequest) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *GoogleAnalytics4ControllerActionPropertyRequest) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetAccountId returns the AccountId field value if set, zero value otherwise.
func (o *GoogleAnalytics4ControllerActionPropertyRequest) GetAccountId() int32 {
	if o == nil || IsNil(o.AccountId) {
		var ret int32
		return ret
	}
	return *o.AccountId
}

// GetAccountIdOk returns a tuple with the AccountId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalytics4ControllerActionPropertyRequest) GetAccountIdOk() (*int32, bool) {
	if o == nil || IsNil(o.AccountId) {
		return nil, false
	}
	return o.AccountId, true
}

// HasAccountId returns a boolean if a field has been set.
func (o *GoogleAnalytics4ControllerActionPropertyRequest) HasAccountId() bool {
	if o != nil && !IsNil(o.AccountId) {
		return true
	}

	return false
}

// SetAccountId gets a reference to the given int32 and assigns it to the AccountId field.
func (o *GoogleAnalytics4ControllerActionPropertyRequest) SetAccountId(v int32) {
	o.AccountId = &v
}

func (o GoogleAnalytics4ControllerActionPropertyRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GoogleAnalytics4ControllerActionPropertyRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.AccountId) {
		toSerialize["accountId"] = o.AccountId
	}
	return toSerialize, nil
}

type NullableGoogleAnalytics4ControllerActionPropertyRequest struct {
	value *GoogleAnalytics4ControllerActionPropertyRequest
	isSet bool
}

func (v NullableGoogleAnalytics4ControllerActionPropertyRequest) Get() *GoogleAnalytics4ControllerActionPropertyRequest {
	return v.value
}

func (v *NullableGoogleAnalytics4ControllerActionPropertyRequest) Set(val *GoogleAnalytics4ControllerActionPropertyRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableGoogleAnalytics4ControllerActionPropertyRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableGoogleAnalytics4ControllerActionPropertyRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGoogleAnalytics4ControllerActionPropertyRequest(val *GoogleAnalytics4ControllerActionPropertyRequest) *NullableGoogleAnalytics4ControllerActionPropertyRequest {
	return &NullableGoogleAnalytics4ControllerActionPropertyRequest{value: val, isSet: true}
}

func (v NullableGoogleAnalytics4ControllerActionPropertyRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGoogleAnalytics4ControllerActionPropertyRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
